package at.jku.ssw.pi.graph.ue07;

import at.jku.ssw.pi.Iterator;
import at.jku.ssw.pi.graph.Graph;
import at.jku.ssw.pi.graph.Vertex;
import at.jku.ssw.pi.list.List;

public class Graphs {

	private static void copyList(List dst, List src) {
		Iterator eit = src.iterator();
		while (eit.hasNext()) {
			dst.insertLast(eit.next());
		}
	}

	private static Graph cloneGraph(Graph g) {
		Graph cloned = new Graph();
		copyList(cloned.vertices, g.vertices);
		copyList(cloned.edges, g.edges);

		return cloned;
	}

	private static void reset(Graph graph) {
		for (int i = 0; i < graph.vertices.size(); i++) {
			Vertex v = (Vertex) graph.vertices.get(i);
			v.minWeight = 0;
			v.distance = 0;
			v.dad = null;
			v.marked = false;
		}
	}

	public static void depthFirstSearch(Graph graph) {
		reset(graph);
		// TODO
	}

	public static void breadthFirstSearch(Graph graph) {
		reset(graph);
		// TODO
	}

	public static Graph makeMinimalSpanningTree(Graph graph, Vertex start) {
		graph = cloneGraph(graph);
		reset(graph);
		// TODO
		return graph;
	}

	public static Graph makeShortestPath(Graph graph, Vertex from, Vertex to) {
		graph = cloneGraph(graph);
		reset(graph);
		// TODO
		return graph;
	}

}
